//+------------------------------------------------------------------+
//|                                                          gcd.mqh |
//|                                 (c) 2011.04.03, Vladimir Gomonov |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "(c) 2011.04.03, Vladimir Gomonov"
#property link      "MetaDriver@rambler.ru"

long gcd(long m, long n) 
{
  if (m<0) m=-m; 
  if (n<0) n=-n;
  if (m==0) return n; 
  if (n==0) return m;
  int d = 0;
  while ((m & 1)==0 && (n & 1)==0) { m >>= 1; n >>= 1; ++d; }
  while ((m & 1)==0) m >>= 1;
  while ((n & 1)==0) n >>= 1;
  while (true) 
    if (m < n) 
    {
      n -= m;
      do  n >>= 1;  while ((n & 1)==0);
    } 
    else if (n < m) 
    {
      m -= n;
      do  m >>= 1;  while ((m & 1)==0);
    } 
    else break;
    return (m <<= d);
}
